package com.diagbot.enums;

import com.diagbot.core.KeyedNamed;
import lombok.Setter;

/**
 * @author zhoutg
 * @Description: 图谱禁忌类型
 * @date 2018年10月11日 下午3:33:22
 */

public enum NeoEnum implements KeyedNamed {

    gender(1, "禁忌性别"),
    ageNeoDTO(2, "禁忌年龄"),
    clinicfindings(3, "禁忌临床表现"),
    oralmeds(4, "禁忌服用药品"),
    allergicmeds(5, "禁忌过敏药品"),
    operations(6, "禁忌手术"),
    procedures(7, "禁忌操作"),
    lis(8, "禁忌实验室检查"),
    pacs(9, "禁忌辅助检查"),
    disease(10, "禁忌疾病"),
    group(11, "禁用人群"),
    conflictmeds(12, "配伍禁忌"),
    vitals(13, "禁忌查体"),
    pacsDesc(14, "禁忌辅助检查描述"),
    medEqu(15, "禁忌医疗器械及物品"),
    exclusion(16, "开单项互斥");

    @Setter
    private int key;

    @Setter
    private String name;

    NeoEnum(int key, String name) {
        this.key = key;
        this.name = name;
    }

    public static NeoEnum getEnum(int key) {
        for (NeoEnum item : NeoEnum.values()) {
            if (item.key == key) {
                return item;
            }
        }
        return null;
    }

    public static String getName(int key) {
        NeoEnum item = getEnum(key);
        return item != null ? item.name : null;
    }

    @Override
    public int getKey() {
        return key;
    }

    @Override
    public String getName() {
        return name;
    }


}
