package com.diagbot.repository;

import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.CombiOpBillNeoDTO;
import com.diagbot.entity.node.*;
import com.diagbot.entity.relationship.*;
import com.diagbot.util.ListUtil;
import com.diagbot.util.NeoUtil;

import java.util.*;

public class CombiOperationNode {

	public CombiOpBillNeoDTO CombiOptoCombiOpDTO(CombiOperation combiOp) {

		CombiOpBillNeoDTO combiOpBillNeoDTO = new CombiOpBillNeoDTO();
		NodeInfo nodeInfo;


		CombiOperationGender combiOpGender = combiOp.getCombiOpgender();
		if (NeoUtil.isExist(combiOpGender)) {
			Gender gender = combiOpGender.getGender();
			nodeInfo = new NodeInfo();
			nodeInfo.setName(gender.getName());
			nodeInfo.setTypeval(Constants.gender);
			combiOpBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
		}


		Set<CombiOperationGroup> combiOpGroups = combiOp.getCombiOpgroups();
		for (CombiOperationGroup combiOpGroup : combiOpGroups) {
			if (NeoUtil.isExist(combiOpGroup)) {
				Group group = combiOpGroup.getGroup();
				nodeInfo = new NodeInfo();
				nodeInfo.setName(group.getName());
				nodeInfo.setTypeval(Constants.group);
				combiOpBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
			}
		}


		Set<CombiOperationLis> combiOplislist = combiOp.getCombiOpLiss();
		for (CombiOperationLis combiOplis : combiOplislist) {
			if (NeoUtil.isExist(combiOplis)) {
				Lis lis = combiOplis.getLis();
				nodeInfo = new NodeInfo();
				nodeInfo.setName(lis.getName());
				nodeInfo.setTypeval(Constants.lis);
				combiOpBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
			}
		}


		Set<CombiOperationPacsDescribe> combiOpPacsDescribes = combiOp.getCombiOppacsdescs();
		for (CombiOperationPacsDescribe combiOpPacsDesc : combiOpPacsDescribes) {
			if (NeoUtil.isExist(combiOpPacsDesc)) {
				PacsDescribe pacsdesc = combiOpPacsDesc.getPacsDescribe();
				nodeInfo = new NodeInfo();
				nodeInfo.setName(pacsdesc.getName());
				nodeInfo.setTypeval(Constants.pacsdesc);
				combiOpBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
			}
		}


		Set<CombiOperationDisease> combiOpDiseases = combiOp.getCombiOpdiseases();
		for (CombiOperationDisease combiOpdisease : combiOpDiseases) {
			if (NeoUtil.isExist(combiOpdisease)) {
				Disease disease = combiOpdisease.getDisease();
				nodeInfo = new NodeInfo();
				nodeInfo.setName(disease.getName());
				nodeInfo.setTypeval(Constants.disease);
				combiOpBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
			}
		}


		Set<CombiOperationMedAllergen> combiOpMedAllergens = combiOp.getCombiOpmedallergens();
		for (CombiOperationMedAllergen combiOpmedallergen : combiOpMedAllergens) {
			if (NeoUtil.isExist(combiOpmedallergen)) {
				MedAllergen medAllergen = combiOpmedallergen.getMedAllergen();
				nodeInfo = new NodeInfo();
				nodeInfo.setName(medAllergen.getName());
				nodeInfo.setTypeval(Constants.medallergen);
				combiOpBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
			}
		}



		return combiOpBillNeoDTO;
	}


	/**
	 * 获取联合项目开单合理性
	 */
	public List<BillNeoDTO> getCombiOpBill(List<Map<String, String>> combitermlist, CombiOperationRepository combiRepository) {

		List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
		BillNeoDTO billNeoDTO;

		CombiOpBillNeoDTO combiOpBillNeoDTO;

		List<CombiOperation> oplist;
		String opname;

		for (Map<String, String> combiterm : combitermlist) {
			for (String term : combiterm.keySet()) {
				billNeoDTO = new BillNeoDTO();
				opname = combiterm.get(term);
				billNeoDTO.setName(term);
				billNeoDTO.setStandname(opname);

				oplist = combiRepository.findByNameIs(opname);

				if (ListUtil.isNotEmpty(oplist)) {
					combiOpBillNeoDTO = CombiOptoCombiOpDTO(oplist.get(0));

					billNeoDTO.setCombiOpBillNeoDTO(combiOpBillNeoDTO);

					billNeoDTOs.add(billNeoDTO);
				}
			}
		}

		return billNeoDTOs;
	}
}

