package com.diagbot.repository;

import com.diagbot.biz.push.entity.Lis;
import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.CriticalNeoDTO;
import com.diagbot.dto.LisBillNeoDTO;
import com.diagbot.dto.LisDetailDTO;
import com.diagbot.dto.NeoEntityDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.entity.node.LisCritical;
import com.diagbot.entity.node.LisName;
import com.diagbot.entity.relationship.LisNameGender;
import com.diagbot.entity.relationship.LisNameGroup;
import com.diagbot.entity.relationship.LisNameLisCritical;
import com.diagbot.entity.relationship.LisNameLisSet;
import com.diagbot.util.ListUtil;
import com.diagbot.util.NeoUtil;
import com.diagbot.util.StringUtil;
import com.diagbot.vo.CriticalNeoVO;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class LisNameNode {

	public LisBillNeoDTO ListoLISDTO(LisName lis) {

		LisBillNeoDTO lisBillNeoDTO = new LisBillNeoDTO();
		NodeInfo nodeInfo;

		LisNameGender lisNameGender = lis.getLisNamegender();
		if (NeoUtil.isExist(lisNameGender) ) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(lisNameGender.getGender().getName());
			nodeInfo.setTypeval(Constants.gender);
			lisBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
		}

/*
		Age age = lis.getAge();
		if (null!=age) {
			NodeNeoDTO ageNeoDTO = new NodeNeoDTO();
			ageNeoDTO.setMin(BigDecimal.valueOf(age.getMinval()));
			ageNeoDTO.setMax(BigDecimal.valueOf(age.getMaxval()));
			ageNeoDTO.setName("年龄");
			lisBillNeoDTO.setAgeNeoDTO(ageNeoDTO);
		}

		Set<ClinicalFinding> clinicalfindings = lis.getClinicalfindings();
		for (ClinicalFinding clinicalfinding : clinicalfindings) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(clinicalfinding.getName());
			nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getMinval()));
			nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getMaxval()));
			nodeInfo.setUnit(clinicalfinding.getUnit());
			nodeInfo.setRange(clinicalfinding.getRange());
			lisBillNeoDTO.getClinicfindings().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Vital> vitals = lis.getVitals();
		for (Vital vital : vitals) {
			nodeInfo = new NodeInfo();
			String name = vital.getName();
			if (name.contains("禁忌")) {
				name = name.substring(name.indexOf("禁忌")+2);
			}
			nodeInfo.setName(name);
			nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(vital.getMinval()));
			nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(vital.getMaxval()));
			nodeInfo.setUnit(vital.getUnit());
			nodeInfo.setRange(vital.getRange());
			lisBillNeoDTO.getVitals().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Medicine> conflict_medicines = lis.getConflict_medicines();
		for (Medicine conflict_medicine : conflict_medicines) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(conflict_medicine.getName());
			lisBillNeoDTO.getOralmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<AllergicMed> allergicmeds = lis.getAllergicmeds();
		for (AllergicMed allergicmed : allergicmeds) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(allergicmed.getName());
			lisBillNeoDTO.getAllergicmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Operation> operations = lis.getOperations();
		for (Operation operation : operations) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(operation.getName());

			lisBillNeoDTO.getOperations().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Procedure> procedures = lis.getProcedures();
		for (Procedure procedure : procedures) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(procedure.getName());

			lisBillNeoDTO.getProcedures().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<PACS> pacss = lis.getPacs();
		for (PACS pacs : pacss) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(pacs.getName());

			lisBillNeoDTO.getPacs().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Disease> diseases = lis.getDiseases();
		for (Disease disease : diseases) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(disease.getName());

			lisBillNeoDTO.getDisease().add(NeoUtil.updateNodeInfo(nodeInfo));
		}
*/
		Set<LisNameGroup> groups = lis.getLisNamegroups();
		for (LisNameGroup group : groups) {
			if (NeoUtil.isExist(group)) {
				nodeInfo = new NodeInfo();
				nodeInfo.setName(group.getGroup().getName());
				nodeInfo.setTypeval(Constants.group);

				lisBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
			}
		}


		return lisBillNeoDTO;
	}


	/**
	 * 处理化验开单合理性
	 */
	public List<BillNeoDTO> getLisDetailBill(List<Map<String, String>> listermlist, LisNameRepository lisRepository) {
		List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
		BillNeoDTO billNeoDTO;

		LisBillNeoDTO lisBillNeoDTO;

		List<LisName> lislist;
		String lisname;

		for (Map<String, String> listerm : listermlist) {
			for (String term : listerm.keySet()) {
				billNeoDTO = new BillNeoDTO();
				lisname = listerm.get(term);
				billNeoDTO.setName(term);
				billNeoDTO.setStandname(lisname);

				lisBillNeoDTO = new LisBillNeoDTO();

				lislist = lisRepository.findByNameIs(lisname);

				if (ListUtil.isNotEmpty(lislist)) {
					lisBillNeoDTO = ListoLISDTO(lislist.get(0));
				}

				billNeoDTO.setLisBillNeoDTO(lisBillNeoDTO);

				billNeoDTOs.add(billNeoDTO);
			}
		}

		return billNeoDTOs;
	}


	/**
	 * 获取化验细项名称列表
	 */
	public List<LisDetailDTO> getLisDetailList(String name, LisNameRepository lisRepository, BaseNodeRepository baseNodeRepository) {
		String nodename, unit;
		Double min, max;

		List<LisDetailDTO> lislist = new ArrayList<>();
		LisDetailDTO lisDetailDTO;

		List<LisName> lislt = lisRepository.index(name, name,100);

		if (ListUtil.isNotEmpty(lislt) && lislt.size() > 100) {
			lislt = lislt.subList(0, 100);
		}

		for (LisName lis : lislt) {
			lisDetailDTO = new LisDetailDTO();
			nodename = lis.getName();
			lisDetailDTO.setUniqueName(nodename);


			if (null != lis.getMaxval()) {
				max = lis.getMaxval();
			}

			if (null != lis.getMinval()) {
				min = lis.getMinval();
			}

			if (StringUtil.isNotBlank(lis.getUnit())) {
				unit = lis.getUnit();
			}

			Set<LisNameLisSet> lisNameSet = lis.getLisNamelissets();
			if (lisNameSet != null && lisNameSet.size() > 0) {
				for (LisNameLisSet lisset : lisNameSet) {
					if (NeoUtil.isExist(lisset)) {
						lisDetailDTO = new LisDetailDTO();
						nodename = lis.getName();
						lisDetailDTO.setUniqueName(nodename);
						lisDetailDTO.setName(lisset.getLisSet().getName());
						lisDetailDTO.setMaxValue(lis.getMaxval());
						lisDetailDTO.setMinValue(lis.getMinval());
						lisDetailDTO.setUnits(lis.getUnit());
						lislist.add(lisDetailDTO);
					}
				}
			} else {
				lisDetailDTO = new LisDetailDTO();
				lisDetailDTO.setUniqueName(lis.getName());
				lisDetailDTO.setName(lis.getName() + "(套餐)");
				lisDetailDTO.setMaxValue(lis.getMaxval());
				lisDetailDTO.setMinValue(lis.getMinval());
				lisDetailDTO.setUnits(lis.getUnit());
				lislist.add(lisDetailDTO);
			}
		}


		return lislist;
	}


	/**
	 * 获取化验细项危急值
	 */
	public List<CriticalNeoDTO> getLisCritialList(CriticalNeoVO criticalNeoVO, LisNameRepository lisRepository) {
		String nodename;
		Double agemin, agemax;

		List<CriticalNeoDTO> lislist = new ArrayList<>();
		CriticalNeoDTO criticalNeoDTO;

		Integer gender = criticalNeoVO.getSex();
		Double age = criticalNeoVO.getAge();
		List<Lis> lisVO = criticalNeoVO.getLis();

		try {
			for (Lis lisvo : lisVO) {

				String name = lisvo.getDetailName();

				if (StringUtil.isNotBlank(name)) {
					List<LisName> lislt = lisRepository.findByNameIs(name);

					for (LisName lis : lislt) {
						criticalNeoDTO = new CriticalNeoDTO();
						nodename = lis.getName();
						criticalNeoDTO.setName(nodename);
						criticalNeoDTO.setStandname(nodename);
						criticalNeoDTO.setType(Constants.huayan);

						List<LisCritical> lisCriticals = new ArrayList<>();

						Set<LisNameLisCritical> lisNameLisCriticals = lis.getLisNameliscritials();

						for (LisNameLisCritical lisNameCritical : lisNameLisCriticals) {
							if (NeoUtil.isExist(lisNameCritical)) {
								lisCriticals.add(lisNameCritical.getLisCritical());
							}
						}

						for (LisCritical lisCritical : lisCriticals) {
							agemin = 0.0D;
							agemax = 0.0D;
							if (lisCritical.getAge().contains(":")) {
								String[] agerange = lisCritical.getAge().split(":");
								agemin = Double.parseDouble(agerange[0]);
								agemax = Double.parseDouble(agerange[1]);
							}

							if (age >= agemin && age <= agemax) {
								NodeNeoDTO nodeNeoDTO = new NodeNeoDTO();

								BigDecimal min = (StringUtil.isNotBlank(lisCritical.getMinval()))
										? (new BigDecimal(lisCritical.getMinval())) : null;
								BigDecimal max = (StringUtil.isNotBlank(lisCritical.getMaxval()))
										? (new BigDecimal(lisCritical.getMaxval())) : null;

								nodeNeoDTO.setMin(min);
								nodeNeoDTO.setMax(max);
								nodeNeoDTO.setUnit(lisCritical.getUnit());
								nodeNeoDTO.setValType(Integer.parseInt(lisCritical.getRange()));
								criticalNeoDTO.setCritical(nodeNeoDTO);

								lislist.add(criticalNeoDTO);
							}
						}

					}
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		return lislist;
	}


	/**
	 * 更新实体属性信息
	 */
	public NeoEntityDTO updateEntity(String name, Map<String, String> props, List<String> keys, LisNameRepository lisRepository) {
		NeoEntityDTO neoEntityDTO = new NeoEntityDTO();
		neoEntityDTO.setName(name);

		try {
			List<LisName> lisres = lisRepository.findByNameIs(name);

			if (lisres != null && lisres.size() > 0) {
				LisName lis = lisres.get(0);

				for (String key : props.keySet()) {
					switch (key) {
						case "最大值":
							lis.setMaxval(Double.parseDouble(props.get(key)));
							break;
						case "最小值":
							lis.setMinval(Double.parseDouble(props.get(key)));
							break;
						case "单位":
							lis.setUnit(props.get(key));
							break;
					}
				}

				lis = lisRepository.save(lis);

				neoEntityDTO = fillNeoDTO(lis, keys);
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		return neoEntityDTO;
	}


	private NeoEntityDTO fillNeoDTO(LisName lis, List<String> keys) {
		NeoEntityDTO neoEntityDTO = new NeoEntityDTO();
		Map<String, String> props = new HashMap<>();
		String val;

		neoEntityDTO.setName(lis.getName());
		for (String key : keys) {
			val = "";
			switch (key) {
				case "最大值":
					val = (lis.getMaxval() == null) ? "" : String.format("%.2f", lis.getMaxval());
					break;
				case "最小值":
					val = (lis.getMinval() == null) ? "" : String.format("%.2f", lis.getMinval());
					break;
				case "单位":
					val = lis.getUnit();
					break;
			}
			if (StringUtil.isNotBlank(val)) {
				props.put(key, val);
			}
		}
		neoEntityDTO.setProperty(props);

		return neoEntityDTO;
	}
}

