package com.diagbot.repository;

import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.DrugBillNeoDTO;
import com.diagbot.dto.DrugInfoDTO;
import com.diagbot.dto.HighRiskNeoDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.entity.node.HerbDeptClass;
import com.diagbot.entity.node.HerbFangJiCate;
import com.diagbot.entity.node.HerbFangJiClass;
import com.diagbot.entity.node.HerbYiBaoClass;
import com.diagbot.entity.node.HerbZhiLiaoClass;
import com.diagbot.entity.node.MedChemClass;
import com.diagbot.entity.node.MedClass;
import com.diagbot.entity.node.MedCode;
import com.diagbot.entity.node.MedCodeName;
import com.diagbot.entity.node.MedJiePouClass;
import com.diagbot.entity.node.MedProdName;
import com.diagbot.entity.node.MedRegName;
import com.diagbot.entity.node.MedYaoLiClass;
import com.diagbot.entity.node.MedYiBaoClass;
import com.diagbot.entity.node.MedZhiLiaoClass;
import com.diagbot.entity.node.Medicine;
import com.diagbot.entity.node.ProdName;
import com.diagbot.entity.node.RegName;
import com.diagbot.entity.relationship.*;
import com.diagbot.util.NeoUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class MedicineCodeNode {


    public DrugBillNeoDTO MedicinetoDrugDTO(MedCodeName medcode) {
        DrugBillNeoDTO drugBillNeoDTO = new DrugBillNeoDTO();
        NodeInfo nodeInfo = new NodeInfo();


        Set<MedCodeNameMedClass> medCodeNameClass = medcode.getMedCodeNameMedclasss();
        for (MedCodeNameMedClass medCls : medCodeNameClass) {
            if (NeoUtil.isExist(medCls)) {
                NodeNeoDTO ageNeoDTO = new NodeNeoDTO();
                nodeInfo.setName(medCls.getMedClass().getName());
                nodeInfo.setTypeval(Constants.medcate);
                drugBillNeoDTO.setAgeNeoDTO(ageNeoDTO);
            }
        }


        Set<MedCodeNameMedRegName> medCodeNameRegNames = medcode.getMedCodeNameMedregnames();
        for (MedCodeNameMedRegName medRegName : medCodeNameRegNames) {
            if (NeoUtil.isExist(medRegName)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(medRegName.getMedRegName().getName());
                nodeInfo.setTypeval(Constants.medregname);
                drugBillNeoDTO.getClinicfindings().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameMedicine> medCodeNamemedicines = medcode.getMedCodeNameMedicines();
        for (MedCodeNameMedicine medicine : medCodeNamemedicines) {
            if (NeoUtil.isExist(medicine)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(medicine.getMedicine().getName());
                nodeInfo.setTypeval(Constants.medicine);
                drugBillNeoDTO.getVitals().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameMedChemClass> medCodeNameChemClasses = medcode.getMedCodeNameMedchemclass();
        for (MedCodeNameMedChemClass medChemCls : medCodeNameChemClasses) {
            if (NeoUtil.isExist(medChemCls)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(medChemCls.getMedChemClass().getName());
                nodeInfo.setTypeval(Constants.medhuaxue);
                drugBillNeoDTO.getLis().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameMedYaoLiClass> medCodeNameYaoLiClasses = medcode.getMedCodeNameMedyaoliclass();
        for (MedCodeNameMedYaoLiClass medYaoLiCls : medCodeNameYaoLiClasses) {
            if (NeoUtil.isExist(medYaoLiCls)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(medYaoLiCls.getMedYaoLiClass().getName());
                nodeInfo.setTypeval(Constants.medyaoli);
                drugBillNeoDTO.getPacs().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameMedZhiLiaoClass> medCodeNameZhiLiaoClasses = medcode.getMedCodeNameMedzhiliaoclass();
        for (MedCodeNameMedZhiLiaoClass medZhiLiaoCls : medCodeNameZhiLiaoClasses) {
            if (NeoUtil.isExist(medZhiLiaoCls)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(medZhiLiaoCls.getMedZhiLiaoClass().getName());
                nodeInfo.setTypeval(NeoUtil.getMedType(medZhiLiaoCls.getMedZhiLiaoClass().getName()));
                drugBillNeoDTO.getAllergicmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameMedJiePouClass> medCodeNameJiePouClasses = medcode.getMedCodeNameMedjiepouclass();
        for (MedCodeNameMedJiePouClass medJiePouCls : medCodeNameJiePouClasses) {
            if (NeoUtil.isExist(medJiePouCls)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(medJiePouCls.getMedJiePouClass().getName());
                nodeInfo.setTypeval(Constants.medjiepou);
                drugBillNeoDTO.getOperations().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameMedCode> medCodeNameCodes = medcode.getMedCodeNameMedcodes();
        for (MedCodeNameMedCode medCode : medCodeNameCodes) {
            if (NeoUtil.isExist(medCode)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(medCode.getMedCode().getName());
                nodeInfo.setTypeval(Constants.medcode);
                drugBillNeoDTO.getMeddevice().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameMedProdName> medCodeNameProdNames = medcode.getMedCodeNameMedprodnames();
        for (MedCodeNameMedProdName medProdName : medCodeNameProdNames) {
            if (NeoUtil.isExist(medProdName)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(medProdName.getMedProdName().getName());
                nodeInfo.setTypeval(Constants.medprodname);
                drugBillNeoDTO.getDisease().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameMedYiBaoClass> medCodeNameYiBaoClasses = medcode.getMedCodeNameMedyibaoclass();
        for (MedCodeNameMedYiBaoClass medYiBaoCls : medCodeNameYiBaoClasses) {
            if (NeoUtil.isExist(medYiBaoCls)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(medYiBaoCls.getMedYiBaoClass().getName());
                nodeInfo.setTypeval(Constants.medyibaocate);
                drugBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameRegName> medCodeNameregNames = medcode.getMedCodeNameRegnames();
        for (MedCodeNameRegName regName : medCodeNameregNames) {
            if (NeoUtil.isExist(regName)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(regName.getRegName().getName());
                nodeInfo.setTypeval(Constants.regname);
                drugBillNeoDTO.getConflictmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameHerbFangJiCate> medCodeNameherbFangJiCates = medcode.getMedCodeNameHerbfangjicates();
        for (MedCodeNameHerbFangJiCate herbFangJiCate : medCodeNameherbFangJiCates) {
            if (NeoUtil.isExist(herbFangJiCate)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(herbFangJiCate.getHerbFangJiCate().getName());
                nodeInfo.setTypeval(Constants.herbfangjicate);
                drugBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameHerbFangJiClass> medCodeNameherbFangJiClass = medcode.getMedCodeNameHerbfangjiclass();
        for (MedCodeNameHerbFangJiClass herbFangJiCls : medCodeNameherbFangJiClass) {
            if (NeoUtil.isExist(herbFangJiCls)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(herbFangJiCls.getHerbFangJiClass().getName());
                nodeInfo.setTypeval(Constants.herbfangjiclass);
                drugBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameHerbZhiLiaoClass> medCodeNameherbZhiLiaoClasses = medcode.getMedCodeNameHerbzhiliaoclass();
        for (MedCodeNameHerbZhiLiaoClass herbZhiLiaoCls : medCodeNameherbZhiLiaoClasses) {
            if (NeoUtil.isExist(herbZhiLiaoCls)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(herbZhiLiaoCls.getHerbZhiLiaoClass().getName());
                nodeInfo.setTypeval(Constants.herbzhiliaocate);
                drugBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameHerbDeptClass> medCodeNameherbDeptClasses = medcode.getMedCodeNameHerbdeptclass();
        for (MedCodeNameHerbDeptClass herbDeptCls : medCodeNameherbDeptClasses) {
            if (NeoUtil.isExist(herbDeptCls)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(herbDeptCls.getHerbDeptClass().getName());
                nodeInfo.setTypeval(Constants.herbdeptcate);
                drugBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameHerbYiBaoClass> medCodeNameherbYiBaoClasses = medcode.getMedCodeNameHerbyibaoclass();
        for (MedCodeNameHerbYiBaoClass herbYiBaoCls : medCodeNameherbYiBaoClasses) {
            if (NeoUtil.isExist(herbYiBaoCls)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(herbYiBaoCls.getHerbYiBaoClass().getName());
                nodeInfo.setTypeval(Constants.herbyibaocate);
                drugBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<MedCodeNameProdName> medCodeNameprodNames = medcode.getMedCodeNameProdnames();
        for (MedCodeNameProdName prodName : medCodeNameprodNames) {
            if (NeoUtil.isExist(prodName)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(prodName.getProdName().getName());
                nodeInfo.setTypeval(Constants.prodname);
                drugBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        return drugBillNeoDTO;
    }


    /**
     * 处理处方开单合理性
     */
    public List<BillNeoDTO> getDrugBill(Map<String, String> medsterm, MedicineCodeRepository medicineRepository) {
        List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
        BillNeoDTO billNeoDTO;

        DrugBillNeoDTO drugBillNeoDTO;

        List<MedCodeName> medicine;
        String medname;

        for (String term : medsterm.keySet()) {
            billNeoDTO = new BillNeoDTO();
            medname = medsterm.get(term);
            billNeoDTO.setName(term);
            billNeoDTO.setStandname(medname);

            drugBillNeoDTO = new DrugBillNeoDTO();

            medicine = medicineRepository.findByNameIs(medname);

            if (medicine != null && medicine.size() > 0) {
                drugBillNeoDTO = MedicinetoDrugDTO(medicine.get(0));

                billNeoDTO.setDrugBillNeoDTO(drugBillNeoDTO);

                billNeoDTOs.add(billNeoDTO);
            }
        }


        return billNeoDTOs;
    }


    /**
     * 获取药品商品名称列表
     */
    public List<DrugInfoDTO> getMedicineList(String name, MedicineCodeRepository medicineRepository) {
        String nodename;

        List<DrugInfoDTO> medslist = new ArrayList<>();
        DrugInfoDTO drugInfoDTO;

        List<MedCodeName> medicines = medicineRepository.findByNameContaining(name);

        for (MedCodeName med : medicines) {
            drugInfoDTO = new DrugInfoDTO();
            nodename = med.getName();

            drugInfoDTO.setName(nodename);
            medslist.add(drugInfoDTO);
        }


        return medslist;
    }


    /**
     * 获取高危药品数据
     */
    public List<HighRiskNeoDTO> getHighRiskDrug(Map<String, String> drugsterm, MedicineCodeRepository medicineRepository) {
        List<HighRiskNeoDTO> highRiskNeoDTOS = new ArrayList<>();
        HighRiskNeoDTO highRiskNeoDTO;
        String drugname;
        List<Medicine> medicine;
        Medicine med;
/*
        for (String term : drugsterm.keySet()) {
            highRiskNeoDTO = new HighRiskNeoDTO();

            drugname = drugsterm.get(term);
            highRiskNeoDTO.setName(term);
            highRiskNeoDTO.setStandname(drugname);

            medicine = medicineRepository.findByNameIs(drugname);

            if (null != medicine && medicine.size()>0) {
                med = medicine.get(0);

                if (null!=med.getRisklevel() && med.getRisklevel().trim().length()>0) {
                    highRiskNeoDTO.setIsHighrisk(true);
                    highRiskNeoDTO.setType("药品");
                    highRiskNeoDTOS.add(highRiskNeoDTO);
                }
            }
        }
*/
        return highRiskNeoDTOS;
    }
}

