package com.diagbot.repository;

import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.PacsBillNeoDTO;
import com.diagbot.entity.BaseNodeInfo;
import com.diagbot.entity.node.Allergen;
import com.diagbot.entity.node.ClinicalFinding;
import com.diagbot.entity.node.ConflictDevice;
import com.diagbot.entity.node.Disease;
import com.diagbot.entity.node.Gender;
import com.diagbot.entity.node.Group;
import com.diagbot.entity.node.Lis;
import com.diagbot.entity.node.MedAllergen;
import com.diagbot.entity.node.OralMedicine;
import com.diagbot.entity.node.PacsDescribe;
import com.diagbot.entity.node.PacsName;
import com.diagbot.entity.node.Vital;
import com.diagbot.entity.relationship.*;
import com.diagbot.util.ListUtil;
import com.diagbot.util.NeoUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

public class PacsNameNode {


    public PacsBillNeoDTO PacstoPACSDTO(PacsName pacs) {
        PacsBillNeoDTO pacsBillNeoDTO = new PacsBillNeoDTO();
        NodeInfo nodeInfo;


        PacsNameGender pacsNamegender = pacs.getPacsNameGender();
        if (NeoUtil.isExist(pacsNamegender)) {
            nodeInfo = new NodeInfo();
            nodeInfo.setName(pacsNamegender.getGender().getName());
            nodeInfo.setTypeval(Constants.gender);
            pacsBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
        }


        Set<PacsNameClinicalFinding> pacsNameclinicalfindings = pacs.getPacsNameClinicalfindings();
        for (PacsNameClinicalFinding clinicalfinding : pacsNameclinicalfindings) {
            if (NeoUtil.isExist(clinicalfinding)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(clinicalfinding.getClinicalFinding().getName());
                nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getClinicalFinding().getMinval()));
                nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getClinicalFinding().getMaxval()));
                nodeInfo.setUnit(clinicalfinding.getClinicalFinding().getUnit());
                nodeInfo.setRange(clinicalfinding.getClinicalFinding().getRange());
                nodeInfo.setTypeval(Constants.clinicalfinding);
                pacsBillNeoDTO.getClinicfindings().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<PacsNameVital> pacsNamevitals = pacs.getPacsNameVitals();
        for (PacsNameVital vital : pacsNamevitals) {
            if (NeoUtil.isExist(vital)) {
                nodeInfo = new NodeInfo();
                String name = vital.getVital().getName();
                nodeInfo.setName(name);
                nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(vital.getVital().getMinval()));
                nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(vital.getVital().getMaxval()));
                nodeInfo.setUnit(vital.getVital().getUnit());
                nodeInfo.setRange(vital.getVital().getRange());
                nodeInfo.setTypeval(Constants.vital);
                pacsBillNeoDTO.getVitals().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<PacsNameLis> pacsNameliss = pacs.getPacsNameLis();
        for (PacsNameLis lis : pacsNameliss) {
            if (NeoUtil.isExist(lis)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(lis.getLis().getName());
                nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(lis.getLis().getMinval()));
                nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(lis.getLis().getMaxval()));
                nodeInfo.setUnit(lis.getLis().getUnit());
                nodeInfo.setRange(lis.getLis().getRange());
                nodeInfo.setTypeval(Constants.lis);
                pacsBillNeoDTO.getLis().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<PacsNamePacsDescribe> pacsNameconflict_pacsdesc = pacs.getPacsNamePacsdescribes();
        for (PacsNamePacsDescribe pacsdesc : pacsNameconflict_pacsdesc) {
            if (NeoUtil.isExist(pacsdesc)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(pacsdesc.getPacsDescribe().getName());
                nodeInfo.setTypeval(Constants.pacsdesc);
                pacsBillNeoDTO.getPacsDesc().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<PacsNameGroup> pacsNamegroups = pacs.getPacsNameGroups();
        for (PacsNameGroup group : pacsNamegroups) {
            if (NeoUtil.isExist(group)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(group.getGroup().getName());
                nodeInfo.setTypeval(Constants.group);
                pacsBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<PacsNameOralMedicine> pacsNameconflict_medicines = pacs.getPacsNameOralmedicines();
        for (PacsNameOralMedicine conflict_medicine : pacsNameconflict_medicines) {
            if (NeoUtil.isExist(conflict_medicine)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(conflict_medicine.getOralMedicine().getName());
                nodeInfo.setTypeval(Constants.yaoping);
                pacsBillNeoDTO.getOralmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<PacsNameMedAllergen> pacsNamemedAllergens = pacs.getPacsNameMedallergens();
        for (PacsNameMedAllergen medAllergen : pacsNamemedAllergens) {
            if (NeoUtil.isExist(medAllergen)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(medAllergen.getMedAllergen().getName());
                nodeInfo.setTypeval(NeoUtil.getMedType(medAllergen.getMedAllergen().getName()));
                pacsBillNeoDTO.getAllergicmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<PacsNameDisease> pacsNamediseases = pacs.getPacsNameDiseases();
        for (PacsNameDisease disease : pacsNamediseases) {
            if (NeoUtil.isExist(disease)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(disease.getDisease().getName());
                nodeInfo.setTypeval(Constants.disease);
                nodeInfo.setMatchtype(disease.getExactMatch());
                pacsBillNeoDTO.getDisease().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<PacsNameAllergen> pacsNameallergens = pacs.getPacsNameAllergens();
        for (PacsNameAllergen allergen : pacsNameallergens) {
            if (NeoUtil.isExist(allergen)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(allergen.getAllergen().getName());
                nodeInfo.setTypeval(Constants.yaoping); // 过敏原归类成药物过敏原，与模型提取匹配
                pacsBillNeoDTO.getAllergicmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<PacsNameConflictDevice> pacsNameconflictDevices = pacs.getPacsNameConflictdevices();
        for (PacsNameConflictDevice conflictDevice : pacsNameconflictDevices) {
            if (NeoUtil.isExist(conflictDevice)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(conflictDevice.getConflictDevice().getName());
                nodeInfo.setTypeval(Constants.conflictdevice);
                pacsBillNeoDTO.getMeddevice().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }


        Set<PacsNamePacsName> pacsNamepacsNames = pacs.getConflictPacsName_out();
        for (PacsNamePacsName pacsName : pacsNamepacsNames) {
            if (NeoUtil.isExist(pacsName)) {
                nodeInfo = new NodeInfo();
                nodeInfo.setName(pacsName.getConflict_pacsName().getName());
                nodeInfo.setTypeval(Constants.fujian);
                pacsBillNeoDTO.getPacsOrder().add(NeoUtil.updateNodeInfo(nodeInfo));
            }
        }

        return pacsBillNeoDTO;
    }


    /**
     * 处理辅检开单合理性
     */
    public List<BillNeoDTO> getPacsBill(List<Map<String, String>> pacslist, PacsNameRepository pacsRepository) {
        List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
        BillNeoDTO billNeoDTO;

        PacsBillNeoDTO pacsBillNeoDTO;

        List<PacsName> pacslt;
        String pacsname;

        for (Map<String, String> pacsterm : pacslist) {
            for (String term : pacsterm.keySet()) {
                billNeoDTO = new BillNeoDTO();
                pacsname = pacsterm.get(term);
                billNeoDTO.setName(term);
                billNeoDTO.setStandname(pacsname);

                pacsBillNeoDTO = new PacsBillNeoDTO();

                pacslt = pacsRepository.findByNameIs(pacsname);

                if (ListUtil.isNotEmpty(pacslt)) {
                    pacsBillNeoDTO = PacstoPACSDTO(pacslt.get(0));
                    billNeoDTO.setPacsBillNeoDTO(pacsBillNeoDTO);

                    billNeoDTOs.add(billNeoDTO);
                }
            }
        }

        return billNeoDTOs;
    }


    /**
     * 获取辅检名称列表
     */
    public List<String> getPACSNameList(String name, PacsNameRepository pacsRepository) {
        String pacsname;

        List<String> pacslist = new ArrayList<>();

        List<PacsName> pacslt = pacsRepository.index(name, name, 100);

        if (ListUtil.isNotEmpty(pacslt) && pacslt.size() > 100) {
            pacslt = pacslt.subList(0, 100);
        }

        for (PacsName pacs : pacslt) {
            pacsname = pacs.getName();
            if (!pacslist.contains(pacsname)) {
                pacslist.add(pacsname);
            }
        }

        return pacslist;
    }

    /**
     * 获取辅检名称列表
     */
    public List<String> getPACSNameAndPACSSubNameList(String name, PacsNameRepository pacsRepository) {

        List<String> pacslist = new ArrayList<>();
        List<BaseNodeInfo> pacslt = pacsRepository.indexMultipleLabel(name, name, 100);

        if (ListUtil.isNotEmpty(pacslt) && pacslt.size() > 100) {
            pacslt = pacslt.subList(0, 100);
        }

        pacslist = pacslt.stream().map(i -> i.getName()).collect(Collectors.toList());

        return pacslist;
    }
}






