package com.diagbot.repository;

import com.diagbot.entity.node.Symptom;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface SymptomNameRepository extends Neo4jRepository<Symptom, Long> {

    List<Symptom> findByNameIs(String name);

    List<Symptom> findByNameIn(List<String> names);

    List<Symptom> findByNameContaining(String name);

    @Query("match(d:医保疾病名称)-[r{典型:1}]->(s) where any(label in labels(s) WHERE label in ['症状', '体征']) and s.name in {py} return d.name")
//    @Query("match(d:医保疾病名称)-[r]->(s) where any(label in labels(s) WHERE label in ['症状', '体征']) and s.name in {py} return d.name")
    List<String> getDisBySymptoms(@Param("py")List<String> symptoms);
}

