package com.diagbot.repository;

import com.diagbot.entity.node.TransfusionRemind;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface TransfusionRemindRepository extends Neo4jRepository<TransfusionRemind, Long> {

    List<TransfusionRemind> findByNameIs(String name);

    List<TransfusionRemind> findByNameContaining(String name);

    @Query("MATCH (n:输血提醒指标) where n.输注类型 contains {name} return distinct(n.输注类型)")
    List<String> findTransfusionByName(@Param("name") String name);

    @Query("MATCH (n:输血提醒指标) where n.输注类型 contains {name} return n")
    List<TransfusionRemind> findByTransfusionName(@Param("name") String name);

    @Query("MATCH (n:输血提醒指标) where n.输注类型 in {names} return distinct(n.输注类型)")
    List<String> findTransfusionByTypeIn(@Param("names") List<String> names);

}

