package com.diagbot.web;

import com.diagbot.dto.NeoEntityDTO;
import com.diagbot.facade.EntityFacade;
import com.diagbot.vo.NeoEntityVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * @Description: 图谱实体API控制层
 * @author: zhoutg
 * @time: 2018/8/30 10:12
 */
@RestController
@RequestMapping("/graph/entity")
@Api(value = "实体API", tags = { "实体API" })
@SuppressWarnings("unchecked")
public class EntityController {

    @Autowired
    private EntityFacade entityFacade;

    @ApiOperation(value = "实体API", notes = "")
    @PostMapping("/initEntity")
    public void initEntity() {
        entityFacade.initEntity();
    }

    @ApiOperation(value = "实体标签API", notes = "")
    @GetMapping("/getLabels")
    public List<String> getLabels() {
        return entityFacade.getLabels();
    }


    @ApiOperation(value = "实体更新API", notes = "")
    @PostMapping("/updateNode")
    public NeoEntityDTO updateNode(@RequestBody NeoEntityVO neoEntityVO) {

        return entityFacade.updateNeoNode(neoEntityVO);
    }

}

